import type { BaseContract, BigNumber, BigNumberish, BytesLike, CallOverrides, ContractTransaction, Overrides, PopulatedTransaction, Signer, utils } from "ethers";
import type { FunctionFragment, Result } from "@ethersproject/abi";
import type { Listener, Provider } from "@ethersproject/providers";
import type { TypedEventFilter, TypedEvent, TypedListener, OnEvent, PromiseOrValue } from "../../../common";
export interface DisbursementCliffInterface extends utils.Interface {
    functions: {
        "calcMaxWithdraw()": FunctionFragment;
        "cliffDate()": FunctionFragment;
        "disbursementPeriod()": FunctionFragment;
        "locked()": FunctionFragment;
        "receiver()": FunctionFragment;
        "startDate()": FunctionFragment;
        "token()": FunctionFragment;
        "unlock()": FunctionFragment;
        "wallet()": FunctionFragment;
        "walletWithdraw()": FunctionFragment;
        "withdraw(address,uint256)": FunctionFragment;
        "withdrawnTokens()": FunctionFragment;
    };
    getFunction(nameOrSignatureOrTopic: "calcMaxWithdraw" | "cliffDate" | "disbursementPeriod" | "locked" | "receiver" | "startDate" | "token" | "unlock" | "wallet" | "walletWithdraw" | "withdraw" | "withdrawnTokens"): FunctionFragment;
    encodeFunctionData(functionFragment: "calcMaxWithdraw", values?: undefined): string;
    encodeFunctionData(functionFragment: "cliffDate", values?: undefined): string;
    encodeFunctionData(functionFragment: "disbursementPeriod", values?: undefined): string;
    encodeFunctionData(functionFragment: "locked", values?: undefined): string;
    encodeFunctionData(functionFragment: "receiver", values?: undefined): string;
    encodeFunctionData(functionFragment: "startDate", values?: undefined): string;
    encodeFunctionData(functionFragment: "token", values?: undefined): string;
    encodeFunctionData(functionFragment: "unlock", values?: undefined): string;
    encodeFunctionData(functionFragment: "wallet", values?: undefined): string;
    encodeFunctionData(functionFragment: "walletWithdraw", values?: undefined): string;
    encodeFunctionData(functionFragment: "withdraw", values: [PromiseOrValue<string>, PromiseOrValue<BigNumberish>]): string;
    encodeFunctionData(functionFragment: "withdrawnTokens", values?: undefined): string;
    decodeFunctionResult(functionFragment: "calcMaxWithdraw", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "cliffDate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "disbursementPeriod", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "locked", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "receiver", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "startDate", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "token", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "unlock", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "wallet", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "walletWithdraw", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdraw", data: BytesLike): Result;
    decodeFunctionResult(functionFragment: "withdrawnTokens", data: BytesLike): Result;
    events: {};
}
export interface DisbursementCliff extends BaseContract {
    connect(signerOrProvider: Signer | Provider | string): this;
    attach(addressOrName: string): this;
    deployed(): Promise<this>;
    interface: DisbursementCliffInterface;
    queryFilter<TEvent extends TypedEvent>(event: TypedEventFilter<TEvent>, fromBlockOrBlockhash?: string | number | undefined, toBlock?: string | number | undefined): Promise<Array<TEvent>>;
    listeners<TEvent extends TypedEvent>(eventFilter?: TypedEventFilter<TEvent>): Array<TypedListener<TEvent>>;
    listeners(eventName?: string): Array<Listener>;
    removeAllListeners<TEvent extends TypedEvent>(eventFilter: TypedEventFilter<TEvent>): this;
    removeAllListeners(eventName?: string): this;
    off: OnEvent<this>;
    on: OnEvent<this>;
    once: OnEvent<this>;
    removeListener: OnEvent<this>;
    functions: {
        calcMaxWithdraw(overrides?: CallOverrides): Promise<[BigNumber]>;
        cliffDate(overrides?: CallOverrides): Promise<[BigNumber]>;
        disbursementPeriod(overrides?: CallOverrides): Promise<[BigNumber]>;
        locked(overrides?: CallOverrides): Promise<[boolean]>;
        receiver(overrides?: CallOverrides): Promise<[string]>;
        startDate(overrides?: CallOverrides): Promise<[BigNumber]>;
        token(overrides?: CallOverrides): Promise<[string]>;
        unlock(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        wallet(overrides?: CallOverrides): Promise<[string]>;
        walletWithdraw(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        withdraw(_to: PromiseOrValue<string>, _value: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<ContractTransaction>;
        withdrawnTokens(overrides?: CallOverrides): Promise<[BigNumber]>;
    };
    calcMaxWithdraw(overrides?: CallOverrides): Promise<BigNumber>;
    cliffDate(overrides?: CallOverrides): Promise<BigNumber>;
    disbursementPeriod(overrides?: CallOverrides): Promise<BigNumber>;
    locked(overrides?: CallOverrides): Promise<boolean>;
    receiver(overrides?: CallOverrides): Promise<string>;
    startDate(overrides?: CallOverrides): Promise<BigNumber>;
    token(overrides?: CallOverrides): Promise<string>;
    unlock(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    wallet(overrides?: CallOverrides): Promise<string>;
    walletWithdraw(overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    withdraw(_to: PromiseOrValue<string>, _value: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
        from?: PromiseOrValue<string>;
    }): Promise<ContractTransaction>;
    withdrawnTokens(overrides?: CallOverrides): Promise<BigNumber>;
    callStatic: {
        calcMaxWithdraw(overrides?: CallOverrides): Promise<BigNumber>;
        cliffDate(overrides?: CallOverrides): Promise<BigNumber>;
        disbursementPeriod(overrides?: CallOverrides): Promise<BigNumber>;
        locked(overrides?: CallOverrides): Promise<boolean>;
        receiver(overrides?: CallOverrides): Promise<string>;
        startDate(overrides?: CallOverrides): Promise<BigNumber>;
        token(overrides?: CallOverrides): Promise<string>;
        unlock(overrides?: CallOverrides): Promise<void>;
        wallet(overrides?: CallOverrides): Promise<string>;
        walletWithdraw(overrides?: CallOverrides): Promise<void>;
        withdraw(_to: PromiseOrValue<string>, _value: PromiseOrValue<BigNumberish>, overrides?: CallOverrides): Promise<void>;
        withdrawnTokens(overrides?: CallOverrides): Promise<BigNumber>;
    };
    filters: {};
    estimateGas: {
        calcMaxWithdraw(overrides?: CallOverrides): Promise<BigNumber>;
        cliffDate(overrides?: CallOverrides): Promise<BigNumber>;
        disbursementPeriod(overrides?: CallOverrides): Promise<BigNumber>;
        locked(overrides?: CallOverrides): Promise<BigNumber>;
        receiver(overrides?: CallOverrides): Promise<BigNumber>;
        startDate(overrides?: CallOverrides): Promise<BigNumber>;
        token(overrides?: CallOverrides): Promise<BigNumber>;
        unlock(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        wallet(overrides?: CallOverrides): Promise<BigNumber>;
        walletWithdraw(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        withdraw(_to: PromiseOrValue<string>, _value: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<BigNumber>;
        withdrawnTokens(overrides?: CallOverrides): Promise<BigNumber>;
    };
    populateTransaction: {
        calcMaxWithdraw(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        cliffDate(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        disbursementPeriod(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        locked(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        receiver(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        startDate(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        token(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        unlock(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        wallet(overrides?: CallOverrides): Promise<PopulatedTransaction>;
        walletWithdraw(overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        withdraw(_to: PromiseOrValue<string>, _value: PromiseOrValue<BigNumberish>, overrides?: Overrides & {
            from?: PromiseOrValue<string>;
        }): Promise<PopulatedTransaction>;
        withdrawnTokens(overrides?: CallOverrides): Promise<PopulatedTransaction>;
    };
}
